#include "old-dpf.h"

static struct dpf_frozen_ir df[] = {
	/*	op		len	r0	r1	imm	*/
	{	DPF_EQI,	2,	1,	0,	0xc00c4501}, /* 0 */
	{	DPF_BITS32I,	0,	0,	0,	0xc}, /* 1 */
	{	DPF_EQI,	3,	1,	0,	0x20}, /* 2 */
	{	DPF_ANDI,	0,	1,	0,	0x20}, /* 3 */
	{	DPF_BITS8I,	0,	0,	0,	0x6}, /* 4 */
	{	DPF_EQI,	2,	1,	0,	0xed}, /* 5 */
	{	DPF_BITS16I,	0,	0,	0,	0x4}, /* 6 */
	{	DPF_EQI,	2,	1,	0,	0x6}, /* 7 */
	{	DPF_BITS8I,	0,	0,	0,	0x9}, /* 8 */
	{	DPF_EQI,	2,	1,	0,	0x4d2}, /* 9 */
	{	DPF_BITS16I,	0,	0,	0,	0x14}, /* 10 */
	{	DPF_EQI,	2,	1,	0,	0x10e1}, /* 11 */
	{	DPF_BITS16I,	0,	0,	0,	0x16}, /* 12 */
};
void *mk_pathfinder(int *sz, int src_port, int dst_port) {
	df[0 + 9].imm = src_port;
	df[2 + 9].imm = dst_port;

	*sz = sizeof df / sizeof df[0];
	return (void *)df;
}

/* filter missing check for src port */
static struct dpf_frozen_ir short_path2[] = {
	/*	op		len	r0	r1	imm	*/
	{	DPF_EQI,	2,	1,	0,	0xc00c4501}, /* 0 */
	{	DPF_BITS32I,	0,	0,	0,	0xc}, /* 1 */
	{	DPF_EQI,	3,	1,	0,	0x20}, /* 2 */
	{	DPF_ANDI,	0,	1,	0,	0x20}, /* 3 */
	{	DPF_BITS8I,	0,	0,	0,	0x6}, /* 4 */
	{	DPF_EQI,	2,	1,	0,	0xed}, /* 5 */
	{	DPF_BITS16I,	0,	0,	0,	0x4}, /* 6 */
	{	DPF_EQI,	2,	1,	0,	0x6}, /* 7 */
	{	DPF_BITS8I,	0,	0,	0,	0x9}, /* 8 */
	{	DPF_EQI,	2,	1,	0,	0x10e1}, /* 11 */
	{	DPF_BITS16I,	0,	0,	0,	0x16}, /* 12 */
};

void *mk_short_path2(int *sz, int dst_port) {
	short_path2[0].imm = dst_port;

	*sz = sizeof short_path2 / sizeof short_path2[0];
	return (void *)short_path2;
}


static struct dpf_frozen_ir short_path[] = {
        /*      op              len     r0      r1      imm     */
        {       DPF_EQI,        2,      1,      0,      0xc00c4501}, /* 0 */
        {       DPF_BITS32I,    0,      0,      0,      0xc}, /* 1 */
        {       DPF_EQI,        3,      1,      0,      0x20}, /* 2 */
        {       DPF_ANDI,       0,      1,      0,      0x20}, /* 3 */
        {       DPF_BITS8I,     0,      0,      0,      0x6}, /* 4 */
        {       DPF_EQI,        2,      1,      0,      0xed}, /* 5 */
        {       DPF_BITS16I,    0,      0,      0,      0x4}, /* 6 */
        {       DPF_EQI,        2,      1,      0,      0x6}, /* 7 */
        {       DPF_BITS8I,     0,      0,      0,      0x9}, /* 8 */
        {       DPF_EQI,        2,      1,      0,      0x4d2}, /* 9 */
        {       DPF_BITS16I,    0,      0,      0,      0x14}, /* 10 */
};
void *mk_short_path(int *sz, int src_port) {
	short_path[0].imm = src_port;
        *sz = sizeof short_path / sizeof short_path[0];
        return (void *)short_path;
}
